/////////////////////////////////////////////////////////////////////////////////////
// Dateiname:		Config.h
/////////////////////////////////////////////////////////////////////////////////////
// Autor:			Christian Roesch
//
// Erstelldatum:	05.08.2001
// letzte nderung:	27.09.2001
/////////////////////////////////////////////////////////////////////////////////////
// Info:	Diese Klasse hlt alle aktuellen Konfigurationsdaten. 
/////////////////////////////////////////////////////////////////////////////////////


#ifndef _GAMEMMODE_ENUM
#define _GAMEMMODE_ENUM
/////////////////////////////////////////////////////////////////////////////////////
//enum fr die SpielModi
enum GameMode
{
SinglePlay,
DeathMatch,
Challenge,
CaptureTheFlag,
EatEmAll
};
#endif
/////////////////////////////////////////////////////////////////////////////////////
/*---------------------------------------------------------------------------------//
Um einen neuen GameMode zu integrieren mssen die SwitchAnweisungen in folgenden
Funktionen geeignet erweitert werden:

Config::loadLevel
Config::getLevelNr
PPGame::prepareGame
PPGame::runGame
PPMenu::renderSubMenu
PPMenu::processSubMenu

sowie eine neue Variable fr die Anzahl der Level in global.h / .cpp hinzugefgt
werden.

//---------------------------------------------------------------------------------*/
/////////////////////////////////////////////////////////////////////////////////////



#ifndef _Config_H
#define _Config_H

// includes
#include <stdio.h>
#include "global.h"
#include "Field.h"
#include "xgameSDK\xinput.h"
#include "xgameSDK\xconfigfile.h"


// Konstanten
const int iNrOfKeys=6;
// Klassen-Deklaration

class	Config
{
public:
			Config(void);
			~Config(void);
//void		setDefault(void);
bool		setKey(int iPlayer, int iNr, int iKeyId);
int			getKey(int iPlayer, int iNr);
void		load(void);
void		save(void);
bool		loadLevel(Field* pfieldDest);
int			getLevelNr(int iDelta=0);

int			m_iGameSpeed;
GameMode	m_gmActual;
int			m_iMapsFree;		//Anzahl freigeschalteter SingePlay Maps
bool		m_bWrapAround;		//geht die Map aussen weiter?
int			m_iWrapAroundTile;	
int			m_iNrOfActivePlayers;

bool		m_bParticles;		//Partikel zeigen?

int			m_iSFXVolume;
int			m_iMusicVolume;

protected:
	
private:
int 		m_iKeyIds[3][iNrOfKeys];
int			m_iActualLevel[5];
};

#endif // _Config_H

class	Config;
enum	GameMode;

/////////////////////////////////////////////////////////////////////////////////////
// Dateiname:		Config.h
/////////////////////////////////////////////////////////////////////////////////////
