/////////////////////////////////////////////////////////////////////////////////////
// Dateiname:		Field.h
/////////////////////////////////////////////////////////////////////////////////////
// Autor:			Christian Roesch
//
// Erstelldatum:	05.08.2001
// letzte nderung:	26.09.2001
/////////////////////////////////////////////////////////////////////////////////////
// Info:	Die Klasse Field verwaltet das Spielfeld in einer 2d-Matrix von Bytes
//			(unsigned chars)
/////////////////////////////////////////////////////////////////////////////////////


#ifndef _Field_H
#define _Field_H

// includes
#include <time.h>
#include "global.h"
#include "particle.h"
#include "XgameSDK\xdisplay.h"
#include "XgameSDK\xsprite.h"

//Konstanten
const int iFieldSizeX=48;
const int iFieldSizeY=48;
const int iNrOfParticles=75;

// Klassen-Deklaration
class	Field
{
public:
		Field(void);
		~Field(void);
int		getTile(int iX, int iY);
bool	setTile(int iX, int iY, int iNewTile, bool bDevMode=false);
bool	freeTile(int iX, int iY);
bool	isTotalEmpty(int iX, int iY);

void	render(	XSurface* pxdDest, 
				XSprite* pxsTileSet,
				int iX, 
				int iY, 
				int iSize, 
				bool bDisplayEmpty=true);

void	renderParticles(	XSurface* pxdDest, 
							XSprite* pxsParticle,
							int iTime,
							int iX, 
							int iY, 
							int iSize);

void	createParticle(		float	fPosX,
							float	fPosY,
							float	fSpeedX,
							float	fSpeedY,
							int		iType);

bool	load(const char* pcFileName);
bool	save(const char* pcFileName);
int		getStartX(int iNr, int iSetX=-1);
int		getStartY(int iNr, int iSetY=-1);
int		getStartDirection(int iNr, int iSetDirection=-1);

protected:

private:

unsigned char*	m_pucFieldData;		//Spielfeld
unsigned char*	m_pucBackupData;	//die eigentliche Map (ohne Schlangen u.a.)
unsigned char*	m_pucDisplayedData;	//die angezeigte Map

int				m_iStartX[3];	// Infos fr die Startpositionen
int				m_iStartY[3];
int				m_iStartDirection[3];

Particle		m_Particles[iNrOfParticles];
int				m_iLastParticleUsed;
};

#endif // _Field_H

class	Field;

/////////////////////////////////////////////////////////////////////////////////////
// Dateiname:		Field.h
/////////////////////////////////////////////////////////////////////////////////////
