/////////////////////////////////////////////////////////////////////////////////////
// Dateiname:		PPOutro.cpp
/////////////////////////////////////////////////////////////////////////////////////
// Autor:			Christian Roesch
//
// Erstelldatum:	14.09.2001
// letzte nderung:	12.10.2001
/////////////////////////////////////////////////////////////////////////////////////
// Info:	Das Outro
/////////////////////////////////////////////////////////////////////////////////////

//includes
#include "PPOutro.h"

// gibt den Abstand der beiden Textzeilen von der Mitte an
const int c_iOffsetY=35;

// Methoden-Definitionen

/////////////////////////////////////////////////////////////////////////////////////
// Methode:			PPOutro::initialize
/////////////////////////////////////////////////////////////////////////////////////
// Info:	Grafiken Laden, Timer zurcksetzen
/////////////////////////////////////////////////////////////////////////////////////
HRESULT PPOutro::initialize(XDisplay* pxdisplayDest)
{
	HRESULT hres;

	XLogging::log(" --- Outro ---\n");

	hres=m_xsurfBackground.initialize(pxdisplayDest,"logo\\backgr.bmp");

	hres=m_xsFX.initialize(pxdisplayDest,"gfx\\outrofx.spr");
	m_xsFX.m_bVisible=true;

	hres=m_xfFont.initialize(pxdisplayDest,"gfx\\outrofont.fnt");

	m_iTimePassed=0;
	m_bFinish=false;
	m_iPage=0;

	return hres;
}

/////////////////////////////////////////////////////////////////////////////////////
// Methode:			PPOutro::unitialize
/////////////////////////////////////////////////////////////////////////////////////
// Info:	Grafiken/Sound kicken
/////////////////////////////////////////////////////////////////////////////////////
HRESULT PPOutro::uninitialize(void)
{
	HRESULT hres;

	hres=m_xsurfBackground.uninitialize();

	hres=m_xsFX.uninitialize();

	hres=m_xfFont.uninitialize();

	return hres;
}

/////////////////////////////////////////////////////////////////////////////////////
// Methode:			PPOutro::recoverFromFocusLost
/////////////////////////////////////////////////////////////////////////////////////
// Info:	holt Surface zurueck
/////////////////////////////////////////////////////////////////////////////////////
HRESULT PPOutro::recoverFromFocusLost(void)
{
	HRESULT hres;

	hres=m_xsurfBackground.restore();

	hres=m_xsFX.restore();

	hres=m_xfFont.restore();

	return hres;	
}

/////////////////////////////////////////////////////////////////////////////////////
// Methode:			PPOutro::run
/////////////////////////////////////////////////////////////////////////////////////
// Info:	Eigentlicher Ablauf des Outros
/////////////////////////////////////////////////////////////////////////////////////
State PPOutro::run(int iTime, XDisplay* pxdisplayDest)
{
	m_iTimePassed+=iTime;

	m_xsurfBackground.blit(pxdisplayDest);

	//Text zeichnen
	if (m_iTimePassed>500)
	{
		if (m_iTimePassed>3500)
			renderText(	pxdisplayDest,
						m_iPage,
						(m_iTimePassed-3500)*(m_iTimePassed-3500)/250);
		else
			renderText(pxdisplayDest,m_iPage);
	}

	//Balken zeichnen
	if (m_iTimePassed<500)
	{
		renderBar(	pxdisplayDest,
					0,
					364-c_iOffsetY-(500-m_iTimePassed)*(500-m_iTimePassed)/450);
		renderBar(	pxdisplayDest,
					0,
					364+c_iOffsetY+(500-m_iTimePassed)*(500-m_iTimePassed)/450);
	}
	else if (m_iTimePassed<1500)
	{
		renderBar(	pxdisplayDest,
					(m_iTimePassed-500)*(m_iTimePassed-500)/750,
					364-c_iOffsetY);
		renderBar(	pxdisplayDest,
					-(m_iTimePassed-500)*(m_iTimePassed-500)/750,
					364+c_iOffsetY);
	}

	if (m_iTimePassed>4200)
	{
		m_iTimePassed=0;
		m_iPage++;
	}

	if (m_iPage> 8 || m_bFinish)
	{
		return WantToQuit;
	}
	
	return Outro;
}

/////////////////////////////////////////////////////////////////////////////////////
// Methode:			PPOutro::renderText
/////////////////////////////////////////////////////////////////////////////////////
// Info:	zeigt den Text der soundsovielten Seite an, er wird im den Offset nach
//			aussen verschoben
/////////////////////////////////////////////////////////////////////////////////////
void PPOutro::renderText(XDisplay* pxdisplayDest,int iPage,int iOffsetX/* =0 */)
{
	const int iY1=370-c_iOffsetY;
	const int iY2=370+c_iOffsetY;

	switch(iPage)
	{
	case 0:
		m_xfFont.textOut(	pxdisplayDest,
							447-iOffsetX,
							iY1,
							"snakez");
		m_xfFont.textOut(	pxdisplayDest,
							324+iOffsetX,
							iY2,
							"a game by tng-soft");
		break;
	case 1:
		m_xfFont.textOut(	pxdisplayDest,
							389-iOffsetX,
							iY1,
							"code and gfx");
		m_xfFont.textOut(	pxdisplayDest,
							353+iOffsetX,
							iY2,
							"christian roesch");
		break;
	case 2:
		m_xfFont.textOut(	pxdisplayDest,
							381-iOffsetX,
							iY1,
							"sfx and music");
		m_xfFont.textOut(	pxdisplayDest,
							335+iOffsetX,
							iY2,
							"joerg warthemann");
		break;
	case 3:
		m_xfFont.textOut(	pxdisplayDest,
							402-iOffsetX,
							iY1,
							"leveldesign");
		m_xfFont.textOut(	pxdisplayDest,
							353+iOffsetX,
							iY2,
							"christian roesch");
		break;
	case 4:
		m_xfFont.textOut(	pxdisplayDest,
							347-iOffsetX,
							iY1,
							"direct-x wrapper");
		m_xfFont.textOut(	pxdisplayDest,
							436+iOffsetX,
							iY2,
							"x-treme");
		break;
	case 5:
		m_xfFont.textOut(	pxdisplayDest,
							278-iOffsetX,
							iY1,
							"additional sfx and music");
		m_xfFont.textOut(	pxdisplayDest,
							353+iOffsetX,
							iY2,
							"christian roesch");
		break;
	case 6:
		m_xfFont.textOut(	pxdisplayDest,
							321-iOffsetX,
							iY1,
							"sound through fmod");
		m_xfFont.textOut(	pxdisplayDest,
							154+iOffsetX,
							iY2,
							"(c) by firelight multimedia 1999-2001");
		break;
	case 7:
		m_xfFont.textOut(	pxdisplayDest,
							110-iOffsetX,
							iY1,
							"nsis - nullsoft scriptable install system");
		m_xfFont.textOut(	pxdisplayDest,
							247+iOffsetX,
							iY2,
							"(c) 1999-2001 nullsoft, inc.");
		break;
	case 8:
		m_xfFont.textOut(	pxdisplayDest,
							491-iOffsetX,
							iY1,
							"(c)");
		m_xfFont.textOut(	pxdisplayDest,
							470+iOffsetX,
							iY2,
							"2001");
		break;
	}
}

/////////////////////////////////////////////////////////////////////////////////////
// Methode:			PPOutro::renderBar
/////////////////////////////////////////////////////////////////////////////////////
// Info:	zeichnet den weissen Streife an die entsprechende (x,y)-Stelle
/////////////////////////////////////////////////////////////////////////////////////
void PPOutro::renderBar(XDisplay* pxdisplayDest,int iX,int iY)
{
	int iCountX=iX;
	m_xsFX.m_lY=iY;

	if (iCountX>0)
	{
		m_xsFX.m_lX=iCountX-256;
		m_xsFX.m_lFrame=1;
		m_xsFX.blit(pxdisplayDest);
	}

	m_xsFX.m_lFrame=0;

	for(;iCountX<iX+1024;iCountX+=256)
	{
		m_xsFX.m_lX=iCountX;
		m_xsFX.blit(pxdisplayDest);
	}

	if (iCountX<1024)
	{
		m_xsFX.m_lX=iCountX;
		m_xsFX.m_lFrame=2;
		m_xsFX.blit(pxdisplayDest);
	}
}

/////////////////////////////////////////////////////////////////////////////////////
// Methode:			PPOutro::wndProc
/////////////////////////////////////////////////////////////////////////////////////
// Info:	wndProc Teil des Outro, sorgt fr Abbruch bei ESC
/////////////////////////////////////////////////////////////////////////////////////
void PPOutro::wndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
		case WM_KEYDOWN:
			switch (wParam)
			{
				case VK_ESCAPE: 
					m_bFinish=true;
					break;
			}	
	}
}

/////////////////////////////////////////////////////////////////////////////////////
// Ende der Datei:	PPOutro.cpp
/////////////////////////////////////////////////////////////////////////////////////
