/////////////////////////////////////////////////////////////////////////////////////
// Dateiname:		Particle.h
/////////////////////////////////////////////////////////////////////////////////////
// Autor:			Christian Roesch
//
// Erstelldatum:	26.09.2001
// letzte nderung:	27.09.2001
/////////////////////////////////////////////////////////////////////////////////////
// Info:	Diese Klasse modelliert simple Partikel			
/////////////////////////////////////////////////////////////////////////////////////


#ifndef _Particle_H
#define _Particle_H

// includes
#include "XgameSDK\xdisplay.h"
#include "XgameSDK\xsprite.h"

// Klassen-Deklaration

const float		fParticleGravity=-0.0000055f;
const int		iParticleOffset=-2; //nach der Grsse der PartikelBilder!
const int		iParticleFrames=4; //Anzahl der PartikelBilder!
const int		iParticleMaxAge=2000; //nach der Grsse der PartikelBilder!

class	Particle
{
public:
	Particle(void);

	void create(	float	fPosX,
					float	fPosY,
					float	fPosZ,
					float	fSpeedX,
					float	fSpeedY,
					float	fSpeedZ,
					int		iType);


	void update(	int			iTime);

	void renderShadow(	XSurface*	pxdDest, 
						XSprite*	pxsParticle,
						int			iX, 
						int			iY, 
						int			iSize);

	void render(	XSurface*	pxdDest, 
					XSprite*	pxsParticle,
					int			iX, 
					int			iY, 
					int			iSize);

	bool active(void);

protected:

private:
	float m_fPosX;
	float m_fPosY;
	float m_fPosZ;
	float m_fSpeedX;
	float m_fSpeedY;
	float m_fSpeedZ;

	int   m_iAge;
	int	  m_iType;//bei Zeichnen werden die entsprechenden Bilder genommen


};

#endif // _Particle_H

class	Particle;

/////////////////////////////////////////////////////////////////////////////////////
// Dateiname:		Particle.h
/////////////////////////////////////////////////////////////////////////////////////
