/////////////////////////////////////////////////////////////////////////////////////
// Dateiname:		Snake.h
/////////////////////////////////////////////////////////////////////////////////////
// Autor:			Christian Roesch
//
// Erstelldatum:	05.08.2001
// letzte nderung:	26.09.2001
/////////////////////////////////////////////////////////////////////////////////////
// Info:	Die Klasse Snake enthlt eine verkettete Liste mit den Teilen einer
//			Schlange. Die Schlange empfngt Befehle wie "WEITERBEWEGEN" o.
//			"RICHTUNG NDERN". Die Richtungsnderungen werden auch in einer Queue
//			geparkt und bei der nchsten Bewegung ausgefhrt
/////////////////////////////////////////////////////////////////////////////////////


#ifndef _Snake_H
#define _Snake_H

// includes
#include "Field.h"

// Struktur fuer einzelnes Schlangenteil
struct SnakePart
{
public:

int			m_iPosX;
int			m_iPosY;
SnakePart*	m_pspNext;		//Nachfolger
SnakePart*	m_pspPrev;		//Vorgnger
/////////////////////////////////////////////////////////////////////////////////////
//   Prev=NULL       <-Prev--     <-Prev--     <-Prev--
//			First		   2nd		    3rd		   Last
//		       --Next->     --Next->     --Next->     Next=NULL
/////////////////////////////////////////////////////////////////////////////////////
};


// Klassen-Deklaration

class	Snake
{
public:
		Snake(int iStartX, int iStartY, int iDirection, int iTileOffset);
		~Snake(void);
void	reset(int iStartX, int iStartY, int iDirection);
int		move(Field* pfieldDest);
void	add(int iSize);
void	changeDirection(int iNewDirection);
bool	alive(void);
void	kill(Field* pfieldDest=NULL, int iRemoveHeadWithTile=-1);
int		remove(Field* pfieldDest,int iPosX=-1, int iPosY=-1);
int		removeUntilHead(Field* pfieldDest, Snake* psnakeDest);
int		getSoundFX(void);
void	emit(Field* pfieldDest,int iType, int iNrOfParticles, bool bImpulse=false);

protected:

private:
void	releaseMemory(void);
int		getdeltaX(int iDirection);
int		getdeltaY(int iDirection);
int		getDirection(int iDeltaX,int iDeltaY);
void	putInQueue(int iDirection);
int		getFromQueue(void);
void	putPart(SnakePart* pspSource, Field* pfieldDest);

int			m_iLength;
int			m_iAdditionalLength;
bool		m_bAlive;
SnakePart*	m_pspFirst;
SnakePart*	m_pspLast;
int			m_iTileOffset; //gibt an beim wievielten Tile die Grafiken beginnen
int			m_iDirection;
int			m_iDirQueue[8];
int			m_iQueueWritePos;
int			m_iQueueReadPos;

int			m_iSoundFX;

};

#endif // _Snake_H

class	Snake;

/////////////////////////////////////////////////////////////////////////////////////
// Dateiname:		Snake.h
/////////////////////////////////////////////////////////////////////////////////////
