/////////////////////////////////////////////////////////////////////////////////////
// Dateiname:		TileSetData.cpp
/////////////////////////////////////////////////////////////////////////////////////
// Autor:			Christian Roesch
//
// Erstelldatum:	06.08.2001
// letzte nderung:	07.09.2001
/////////////////////////////////////////////////////////////////////////////////////
// Info:	Diese Datei enthlt die Daten ber das TileSet
/////////////////////////////////////////////////////////////////////////////////////

//includes
#include "TileSetData.h"

// Methoden-Definitionen

/////////////////////////////////////////////////////////////////////////////////////
// Methode:			TileSetData::TileSetData
/////////////////////////////////////////////////////////////////////////////////////
// Info:	Konstruktor, initialisiert alle Member der Klasse
/////////////////////////////////////////////////////////////////////////////////////
TileSetData::TileSetData(void)
:m_iLastFree(63)
,m_iFirstEatable(32)
,m_iLastEmpty(15)
,m_iFirstSnake(128)
,m_iRainbow(16)
,m_iFlag(49)
,m_iRedBase(17)
,m_iBlueBase(18)
{
	//TileSets der Spieler beginnen bei
	m_iPlayerOffsets[0]=128;
	m_iPlayerOffsets[1]=160;
	m_iPlayerOffsets[2]=192;

	// Tile[n][m] der Schlange, wenn Schlange aus Richtung n kommt und nach m geht

	//Schlange kommt von oben
	m_iSnakeOffsets[0][0]=0;//und geht nach oben 
	m_iSnakeOffsets[0][1]=5;//und geht nach rechts
	m_iSnakeOffsets[0][2]=1;//und geht nach unten 
	m_iSnakeOffsets[0][3]=4;//und geht nach links
	m_iSnakeOffsets[0][4]=6;//und geht nirgendswo hin (Kopf)
	//Schlange kommt von rechts
	m_iSnakeOffsets[1][0]=5;//und geht nach oben 
	m_iSnakeOffsets[1][1]=0;//und geht nach rechts
	m_iSnakeOffsets[1][2]=2;//und geht nach unten 
	m_iSnakeOffsets[1][3]=0;//und geht nach linkss
	m_iSnakeOffsets[1][4]=7;//und geht nirgendswo hin (Kopf)
	//Schlange kommt von unten
	m_iSnakeOffsets[2][0]=1;//und geht nach oben 
	m_iSnakeOffsets[2][1]=2;//und geht nach rechts
	m_iSnakeOffsets[2][2]=0;//und geht nach unten 
	m_iSnakeOffsets[2][3]=3;//und geht nach links
	m_iSnakeOffsets[2][4]=8;//und geht nirgendswo hin (Kopf)
	//Schlange kommt von links
	m_iSnakeOffsets[3][0]=4;//und geht nach oben 
	m_iSnakeOffsets[3][1]=0;//und geht nach rechts
	m_iSnakeOffsets[3][2]=3;//und geht nach unten 
	m_iSnakeOffsets[3][3]=0;//und geht nach links
	m_iSnakeOffsets[3][4]=9;//und geht nirgendswo hin (Kopf)
	//Schlange kommt von nirgendswo (Schwanz)
	m_iSnakeOffsets[4][0]=11;//und geht nach oben 
	m_iSnakeOffsets[4][1]=12;//und geht nach rechts
	m_iSnakeOffsets[4][2]=13;//und geht nach unten 
	m_iSnakeOffsets[4][3]=10;//und geht nach links
	m_iSnakeOffsets[4][4]=9;//und geht nirgendswo hin (Kopf)
}

/////////////////////////////////////////////////////////////////////////////////////
// Methode:			TileSetData::getPlayerTileOffset
/////////////////////////////////////////////////////////////////////////////////////
// Info:	gibt TileOffset des nten Spielers zurck
/////////////////////////////////////////////////////////////////////////////////////
int TileSetData::getPlayerTileOffset(int iPlayerNr)
{
	if (iPlayerNr<0 || iPlayerNr>2) return -1; //WTF?

	return m_iPlayerOffsets[iPlayerNr];
}

/////////////////////////////////////////////////////////////////////////////////////
// Methode:			TileSetData::
/////////////////////////////////////////////////////////////////////////////////////
// Info:	gibt Offset des Schlangenteils zurck, das mit den beiden Richtungen 
//			passt
/////////////////////////////////////////////////////////////////////////////////////
int TileSetData::getSnakeTileOffset(int iPrevDir, int iNextDir)
{
	if (iPrevDir<0 ||
		iPrevDir>4 ||
		iNextDir<0 ||
		iNextDir>4)
	return 0;

	return m_iSnakeOffsets[iPrevDir][iNextDir];
}

/////////////////////////////////////////////////////////////////////////////////////
// Ende der Datei:	TileSetData.cpp
/////////////////////////////////////////////////////////////////////////////////////
