/////////////////////////////////////////////////////////////////////////////////////
// Dateiname:		XConfigFile.cpp
/////////////////////////////////////////////////////////////////////////////////////
// Autor:			pHreak (pHreak@x-treme-online.de)
//
// Erstelldatum:	17.08.2001
// letzte Aenderung:17.08.2001
/////////////////////////////////////////////////////////////////////////////////////
// Info:			Die Klasse XConfigFile dient zur Ermittlung von Parametern aus
//					einer Konfigurations-Datei.
/////////////////////////////////////////////////////////////////////////////////////
// Copyright 2000/2001 by x-treme (www.x-treme-online.de)
/////////////////////////////////////////////////////////////////////////////////////

#ifndef _XCONFIGFILE_H
#define _XCONFIGFILE_H

// includes
#define WIN32_LEAN_AND_MEAN		// Selten genutzte Teile aus Win-Header ausschliessen
#include <windows.h>
#include <fstream.h>

// Forward-Deklarationen

// Klassen-Deklaration
class	XConfigFile
{
public:
	XConfigFile(const char	*pcConfigFile);
	virtual ~XConfigFile();

	HRESULT getAsString(const char	*pcParam,
						char		*pcValue,
						size_t		sizeValue,
						const char	*pcDefault	= "");
	
	HRESULT getAsInt(const char		*pcParam,
					 int			&nValue,
					 int			nDefault	= 0);

	HRESULT getAsBool(const char	*pcParam,
					  bool			&bValue,
					  bool			bDefault	= false);

	HRESULT getAsDouble(const char	*pcParam,
						double		&dValue,
						double		dDefault	= 0.0);
	
protected:
	HRESULT parseKeyValuePair(const char	*pcParam,
							  char			*pcValue,
							  size_t		sizeValue);

	char		*m_pcConfigFile;
	ifstream	m_file;

private:

};

#endif//_XCONFIGFILE_H

class	XConfigFile;

/////////////////////////////////////////////////////////////////////////////////////
// Ende der Datei:	XConfigFile.h
/////////////////////////////////////////////////////////////////////////////////////