/////////////////////////////////////////////////////////////////////////////////////
// Dateiname:		XFont.h
/////////////////////////////////////////////////////////////////////////////////////
// Autor:			pHreak
//
// Erstelldatum:	30.08.2000
// letzte nderung:	15.03.2001
/////////////////////////////////////////////////////////////////////////////////////
// Info:			Die Klasse XFont verwaltet einen bitmapbasierten Zeichensatz.
/////////////////////////////////////////////////////////////////////////////////////
// Copyright 2000/2001 by x-treme
/////////////////////////////////////////////////////////////////////////////////////

#define DIRECTDRAW_VERSION 0x0700 // Dann klappts auch mit dem "DirectX>7-SDK"-Nachbarn

#define WIN32_LEAN_AND_MEAN		// Selten genutzte Teile aus Win-Header ausschliessen

#ifndef _XFONT_H
#define _XFONT_H

// includes
#include <windows.h>

// XGame-includes
#include "XDisplay.h"
#include "XSurface.h"
#include "XLogging.h"

// Klassen-Deklaration

class	XFont
{
public:
	XFont(void);
	virtual ~XFont(void);

	virtual HRESULT initialize(XDisplay*	pXDisplay,
							   LPSTR		lpstrFontfile);

	virtual HRESULT uninitialize(void);

	HRESULT textOut(XSurface*	lpDestinationXSurface,
					long		lX,
					long		lY,
					LPSTR		lpstrText,
					DWORD		dwFlags = DDBLT_KEYSRC | DDBLT_WAIT);

	virtual HRESULT restore(void);

protected:
	virtual void resetData(void);

private:
	bool		m_bIsInitialized;
	XSurface	m_XSurfaceCharset;
	long		m_lNrOfChars,
				m_lHeight;
	long*		m_plWidth;
	long*		m_plKerning;
	LPSTR		m_lpstrSubstitutionString,
				m_lpstrFilename;
};

#endif//_XFONT_H

class	XFont;

/////////////////////////////////////////////////////////////////////////////////////
// Ende der Datei:	XFont.h
/////////////////////////////////////////////////////////////////////////////////////